<template>
  <v-hover v-slot="{ hover }" open-delay="200">
    <v-card class="mx-auto" :elevation="hover ? 16 : 1">
      <div align="center">
        <v-avatar color="yellow darken-2" class="my-2">
          <v-icon class="mx-1">mdi-lock</v-icon>
        </v-avatar>
        <br />
        <span class="font-weight-medium">24 Locker</span>
      </div>
      <v-card-text>
        <v-form
          ref="form"
          v-model="valid"
          lazy-validation
          @submit="handleLogin"
        >
          <InputLoginForm
            :email.sync="obj.email"
            :password.sync="obj.password"
          />
          <div class="my-1">
            <v-btn
              type="submit"
              :loading="loading"
              :disabled="loading"
              color="info"
              depressed
              block
              medium
            >
              Log In
            </v-btn>
          </div>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-hover>
</template>

<script>
import InputLoginForm from "./InputLoginForm";

export default {
  components: {
    InputLoginForm,
  },
  data() {
    return {
      valid: true,
      obj: {},
      loading: false,
    };
  },
  methods: {
    async handleLogin(e) {
      e.preventDefault();
      const formValid = this.$refs.form.validate();
      if (formValid === true) {
        this.loading = true;
        const param = {
          Email: this.obj.email,
          Password: this.obj.password,
        };
        await this.$store.dispatch("auth/login", param);
        const valid = localStorage.getItem("user");
        if (valid != null) {
          this.loading = false;
          await this.$store.dispatch("snackbar/showSnack", {
            text: "Login Success",
            color: "success",
            timeout: 3500,
          });
          window.location.href = "/dashboard";
        } else {
          this.loading = false;
          await this.$store.dispatch("snackbar/showSnack", {
            text: "Email or password ผิด",
            color: "red",
            timeout: 3500,
          });
        }
      }
    },
  },
};
</script>

<style></style>
